// 			Fragile Base Class problem and solutions
// An original Vendor's A "implementation" of the  C++ iostream library
// Emulation would probably be a better word...

#include "iostream_v1.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#ifndef unix
inline char * strdup(const char * str) { return strcpy(new char [strlen(str)+1],str); }
#endif

					// Emulating Filebuf
Filebuf::Filebuf(const char * fname, const int mode)
	: file_name(strdup(fname))
{
  fprintf(stderr,"constructing Filebuf for a file '%s'\n",file_name);
}

Filebuf::~Filebuf(void)
{
  fprintf(stderr,"closing the file '%s' and destroying the Filebuf\n",file_name);
}

void Filebuf::xsputn(const char * str, const int size)
{
  fprintf(stderr,"writing the following string into the file '%s'\n  >%.*s<\n",
  	file_name,size,str);
} 



					// Emulating Strstream
Strstream::Strstream(void)
	: curr_ptr(0), frozen_flag(false)
{
}

void Strstream::seekoff(const int offset)
{
  assert(offset >= 0 && offset < buffer_size);
  curr_ptr = offset;
}

void Strstream::freeze(const int n)
{
  frozen_flag = n != 0;
}

int Strstream::pcount(void)
{
  frozen_flag = true;
  return curr_ptr;
}

char * Strstream::str(void)
{
  frozen_flag = true;
  assert(curr_ptr < buffer_size);
  buffer[curr_ptr++] = '\0';		// make sure the stream buffer is properly terminated
  return buffer;					// for a C string
}

Strstream& Strstream::operator << (const char * str)
{
  assert( ! frozen_flag );
  const int new_curr_ptr = curr_ptr + strlen(str);
  assert( new_curr_ptr < buffer_size - 1 );		// reserve a place for the end \0
  memcpy(buffer+curr_ptr,str,strlen(str));
  curr_ptr = new_curr_ptr;
  return *this;
}
