// 			Fragile Base Class problem and solutions
//
// An original release of "C++ iostream library" distributed by Vendor A
//
// A terribly (terrifying?) dumbed-down version of the real C++ stream
// library. Still, it maintains some resemblance to filebuf and strstream
// classes of the real thing. Please refer to the C++ stream library documentation
// for description of these classes and their methods.

#ifndef __GNUC__
#pragma once
#endif

#ifndef _iostream_v1_h
#define _iostream_v1_h

				// An impersonation of a real filebuf class
class Filebuf
{ 
 const char * const file_name; 
public:
  Filebuf(const char * fname, const int mode);
  ~Filebuf(void);
  void xsputn(const char * str, const int size); 
};

				// An impersonation of a real strstream class
class Strstream
{
  enum { buffer_size = 1000 };
  char buffer[buffer_size];			// statically allocated buffer
  int curr_ptr;						// current position in the buffer
  bool frozen_flag;

public:
  Strstream(void);
  void seekoff(const int offset);
  virtual void freeze(const int n=1);	// virtual is important here!!!
  
  							// This and the following function implicitly
  							// freeze the buffer: we merely follow behavior
  							// of the real strstream class
  int pcount(void);
  virtual char *str(void);				// virtual is important here!!!

  Strstream& operator << (const char *);
};

#endif
