// 			Fragile Base Class problem and solutions
//
// A modified version of the end user code root_v1.cc, taking advantage
// of the new, thread-safe version of Strstream (provided by Vendor A as
// a class strstream_v2). Vendor's B transaction stream class remains intact,
// yet now it locks the stream buffer during the time of committing it.

#include "transstream_v1.h"
#include "strstream_v2.h"

class MyTransaction: virtual public strstream_v2, public transaction_fofstream
{
public:
  MyTransaction(const char * file_name) : transaction_fofstream(file_name) {}
};

main(void)
{
  MyTransaction transaction_stream("logfile");
  transaction_stream << "logging";
  transaction_stream << "  .... and logging" << "\n";
  transaction_stream.commit();
  transaction_stream << "transaction 2 logging";
  transaction_stream.backoff();
  transaction_stream << "transaction 3 logging";
  transaction_stream.commit();
  return 0;
}
