// 			Fragile Base Class problem and solutions
//
// The "body" of Vendor's B transaction package, class transaction_fofstream

#include "transstream_v1.h"
#include <stdio.h>

transaction_fofstream::transaction_fofstream(const char * file_name)
	: output_buffer(new Filebuf(file_name,0))
{
}

transaction_fofstream::~transaction_fofstream(void)
{
  delete output_buffer;
}

void transaction_fofstream::backoff(void)
{
  seekoff(0);
}

void transaction_fofstream::commit(void)
{
  output_buffer->xsputn(str(),pcount());	// pcount() and str() implicitly freeze the strbuf
  freeze(0);								// so we have to thaw it afterwards
  backoff();						// empty the working buffer to prepare it for the next
  									// transaction
}  
